class Hash
  
  def arrayify
    [self]
  end
  
  def to_query_string(escape_string=false)
    if escape_string
      URI.escape(self.reject{ |k,v| v=="" }.map{ |k,v| "#{k.to_s}=#{v.to_s.gsub(%r{\s},'+')}" }.join("&"))
    else
      self.reject{ |k,v| v == "" }.map{ |k,v| "#{k.to_s}=#{v.to_s.gsub(%r{\s},'+')}" }.join("&")
    end
  end
  
  def rename_key(old_key, new_key)
    return Hash.rename_key(self.dup, old_key, new_key)
  end
  
  def rename_key!(old_key, new_key)
    return Hash.rename_key(self, old_key, new_key)
  end
  
  private
  
  def self.rename_key(hsh, old_key, new_key)
    hsh[new_key.to_s] = hsh.delete(old_key.to_s)
    return hsh
  end
  
end